#version 120
//
// pass1.vert
//
#define AMBIENT_ONLY 0

varying vec4 diffspec;                                                // gUˌ D + ʔˌ S
varying vec4 ambient;                                                 // ̔ˌ A
varying vec3 position;                                                // ̕\ʏ̈ʒu P
varying vec3 normal;                                                  // ̓_̖@xNg N

void main(void)
{
  position = vec3(gl_ModelViewMatrix * gl_Vertex);
  normal = normalize(gl_NormalMatrix * gl_Normal);
  
  vec3 light = normalize(gl_LightSource[0].position.xyz - position);  // ̓_ɌxNg L
  vec3 view = -normalize(position);                                   // ̓_王_ɌxNg V
  vec3 halfway = normalize(light + view);                             // ԃxNg H
  
  float nl = dot(normal, light);
  float nh = pow(dot(normal, halfway), gl_FrontMaterial.shininess);

  // gUˌ{ʔˌ diffspec Ɋi[
  diffspec = gl_FrontMaterial.diffuse * vec4(vec3(nl), 1.0) * gl_LightSource[0].diffuse + gl_FrontMaterial.specular * vec4(vec3(nh), 1.0) * gl_LightSource[0].specular;

  //  ambient Ɋi[
  ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
  
  gl_Position = ftransform();                                         // _ʒu̍Wϊ
}
